diff --git a/scintilla/lexers/LexAHK2.cxx b/scintilla/lexers/LexAHK2.cxx
new file mode 100644
index 0000000..5c51104
--- /dev/null
+++ b/scintilla/lexers/LexAHK2.cxx
@@ -0,0 +1,1606 @@
+// Scintilla source code edit control
+/** @file LexAHK2.cxx
+ ** Lexer for AutoHotkey v2
+ ** Written by fincs
+ **/
+// Copyright 1998-2014 by Neil Hodgson <neilh@scintilla.org>
+// The License.txt file describes the conditions under which this software may be distributed.
+
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include <stdio.h>
+#include <stdarg.h>
+#include <assert.h>
+
+#include <string>
+#include <vector>
+#include <map>
+#include <algorithm>
+
+#include "ILexer.h"
+#include "Scintilla.h"
+#include "SciLexer.h"
+
+#include "WordList.h"
+#include "LexAccessor.h"
+#include "Accessor.h"
+#include "StyleContext.h"
+#include "CharacterSet.h"
+#include "LexerModule.h"
+#include "OptionSet.h"
+#include "SparseState.h"
+
+struct OptionsAHK2
+{
+	bool Fold;
+	bool FoldComment;
+	bool FoldCompact;
+
+	OptionsAHK2() { }
+};
+
+static const char* const ahk2WordListDesc[] =
+{
+	"Built-in Functions",
+	"Built-in Variables",
+	"Flow of Control",
+	"Word Operators",
+	"Keys and Buttons",
+	"Built-in Object Properties",
+	"Built-in Object Methods",
+	NULL
+};
+
+struct OptionSetAHK2 : public OptionSet<OptionsAHK2>
+{
+	OptionSetAHK2()
+	{
+		DefineWordListSets(ahk2WordListDesc);
+
+		DefineProperty("fold", &OptionsAHK2::Fold);
+
+		DefineProperty("fold.compact", &OptionsAHK2::FoldCompact);
+
+		DefineProperty("fold.comment", &OptionsAHK2::FoldComment,
+			"This option enables folding multi-line comments and explicit fold points when using the AutoHotkey v2 lexer."
+			" Explicit fold points allows adding extra folding by placing a ;{ comment at the start and a ;}"
+			" at the end of a section that should fold.");
+	}
+};
+
+typedef enum
+{
+	LINE_NODATA,
+	LINE_BLANK, LINE_MLCOMMENT, LINE_COMMAND, LINE_EXPR, LINE_CONTSECT, LINE_LABEL, LINE_HOTKEY, LINE_REMAP, LINE_HOTSTRING, LINE_DIRECTIVE,
+} AhkLineType;
+
+// These are used for the %expression% stack
+enum
+{
+	DT_VAR,        // Double deref in expression
+	DT_STRING,     // Quoted string with %interpolation%
+	DT_CMDSTRING,  // String in traditional command syntax with %interpolation%
+	DT_CMDSTRING2, // Used for % forceExpressionMode in command syntax
+};
+
+#define MAX_NESTED_EXPR 5 // Same as Ruby lexer.
+
+struct AhkLineInfo
+{
+	AhkLineType type;
+	AhkLineType context;
+
+	bool bCSWouldBeCmdExpr, bEndedInStr;
+	bool bCSCmdExpr2;
+	bool bIsIf;
+	int CSCmdExprBraceNest;
+	bool CSCmdExprSQString;
+	int specialState;
+
+	// These are used in continuation sections
+	bool bLiteralComment, bLiteralQuote, bLiteralPercent, bLiteralComma, bLiteralEscape;
+
+	// Nested expr information
+	int NestedExprPos;
+	char NestedExprCtx[MAX_NESTED_EXPR];
+	char NestedExprBrace[MAX_NESTED_EXPR+1];
+	bool NestedExprSQString[MAX_NESTED_EXPR+1];
+
+	AhkLineInfo()
+	{
+		Init();
+	}
+
+	void Init()
+	{
+		type = LINE_NODATA;
+		context = LINE_BLANK;
+		bCSWouldBeCmdExpr = false;
+		bEndedInStr = false;
+		bIsIf = false;
+		CSCmdExprBraceNest = 0;
+		CSCmdExprSQString = false;
+		specialState = 0;
+
+		bLiteralComment = false;
+		bLiteralQuote = false;
+		bLiteralPercent = false;
+		bLiteralComma = false;
+		bLiteralEscape = false;
+
+		NestedExprPos = 0;
+		NestedExprBrace[0] = 0;
+		NestedExprSQString[0] = false;
+	}
+
+	void InitContext(const AhkLineInfo& base)
+	{
+		memcpy(this, &base, sizeof(*this));
+	}
+
+	bool EnterNestedExpr(int type)
+	{
+		if (NestedExprPos == MAX_NESTED_EXPR)
+			return false;
+		NestedExprCtx[NestedExprPos++] = type;
+		NestedExprBrace[NestedExprPos] = 0;
+		NestedExprSQString[NestedExprPos] = false;
+		return true;
+	}
+
+	int LeaveNestedExpr()
+	{
+		if (NestedExprPos == 0)
+			return -1;
+		return NestedExprCtx[--NestedExprPos];
+	}
+
+	bool InNestedExpr()
+	{
+		return !!NestedExprPos;
+	}
+
+	int CurNestedExprCtx()
+	{
+		return NestedExprPos ? NestedExprCtx[NestedExprPos-1] : -1;
+	}
+
+	void ResetStack(bool varsToo = true)
+	{
+		if (varsToo)
+		{
+			bCSWouldBeCmdExpr = false;
+			bEndedInStr = false;
+		}
+		NestedExprPos = 0;
+		NestedExprBrace[0] = 0;
+	}
+
+	void EnterBrace() { NestedExprBrace[NestedExprPos] ++; }
+	void LeaveBrace() { NestedExprBrace[NestedExprPos] --; }
+	bool IsOutsideBrace() { return !NestedExprBrace[NestedExprPos]; }
+
+	bool IsSQString() { return NestedExprSQString[NestedExprPos]; }
+	void SetSQString(bool b) { NestedExprSQString[NestedExprPos] = b; }
+
+	bool IsSpecial() { return context == LINE_HOTKEY || context == LINE_REMAP || context == LINE_HOTSTRING; }
+};
+
+class AhkProvideLineInfo
+{
+	std::vector<AhkLineInfo> st;
+public:
+	AhkLineInfo& get(int line)
+	{
+		assert (line >= 0);
+		if ((size_t) line >= st.size())
+		{
+			st.resize(line+1);
+			st[line] = AhkLineInfo();
+			return st[line];
+		}else
+			return st[line];
+	}
+};
+
+class LexerAHK2 : public ILexer
+{
+	OptionsAHK2 options;
+	OptionSetAHK2 opSet;
+	WordList bifList, bivList, flowOfControl, wordOps, keys, biObjProps, biObjMethods;
+	AhkProvideLineInfo linfos;
+
+	LexerAHK2() { }
+	~LexerAHK2() { }
+
+public:
+
+	virtual int SCI_METHOD Version() const { return lvOriginal; }
+	virtual void SCI_METHOD Release() { delete this; }
+	virtual const char* SCI_METHOD PropertyNames() { return opSet.PropertyNames(); }
+	virtual int SCI_METHOD PropertyType(const char* name) { return opSet.PropertyType(name); }
+	virtual const char* SCI_METHOD DescribeProperty(const char* name) { return opSet.DescribeProperty(name); }
+	virtual int SCI_METHOD PropertySet(const char* key, const char* val);
+	virtual const char* SCI_METHOD DescribeWordListSets() { return opSet.DescribeWordListSets(); }
+	virtual int SCI_METHOD WordListSet(int n, const char* wl);
+	virtual void SCI_METHOD Lex(unsigned int startPos, int lengthDoc, int initStyle, IDocument* pAccess);
+	virtual void SCI_METHOD Fold(unsigned int startPos, int lengthDoc, int initStyle, IDocument* pAccess);
+	virtual void* SCI_METHOD PrivateCall(int operation, void* pointer) { return NULL; }
+
+	static ILexer* LexerFactoryAHK2()
+	{
+		try { return new LexerAHK2(); }
+		catch(...) { return NULL; }
+	}
+};
+
+int SCI_METHOD LexerAHK2::PropertySet(const char* key, const char* val)
+{
+	return opSet.PropertySet(&options, key, val) ? 0 : -1;
+}
+
+int SCI_METHOD LexerAHK2::WordListSet(int n, const char* wl)
+{
+	WordList* pWl = NULL;
+	switch(n)
+	{
+		case 0: pWl = &bifList; break;
+		case 1: pWl = &bivList; break;
+		case 2: pWl = &flowOfControl; break;
+		case 3: pWl = &wordOps; break;
+		case 4: pWl = &keys; break;
+		case 5: pWl = &biObjProps; break;
+		case 6: pWl = &biObjMethods; break;
+		default: return -1;
+	}
+	pWl->Set(wl);
+	return 0;
+}
+
+LexerModule lmAHK2(SCLEX_AHK2, LexerAHK2::LexerFactoryAHK2, "ahk2", ahk2WordListDesc);
+
+//
+// End of boilerplate
+//
+
+static inline bool isWhitespace(int c)
+{
+	return c == ' ' || c == '\t';
+}
+
+static inline bool isNumeric(int c, bool allowHex = false)
+{
+	return (c >= '0' && c <= '9') || (allowHex && ((c >= 'A' && c <= 'F') || (c >= 'a' && c <= 'f')));
+}
+
+static inline bool isIdChar(int c, bool allowNumeric = true)
+{
+	return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (allowNumeric && isNumeric(c)) || c == '_' || c > 0x7F;
+}
+
+static inline bool isExprOp(int c)
+{
+	return c == '+' || c == '-' || c == '*' || c == '/' || c == '.' || c == '(' || c == ')' || c == '=' || c == '[' || c == ']' 
+		|| c == '!' || c == '<' || c == '>' || c == '&' || c == '|' || c == '^' || c == '~' || c == '?' || c == ':' || c == ',';
+}
+
+static inline bool isOpeningBrace(int c)
+{
+	return c == '(' || c == '[' || c == '{';
+}
+
+static inline bool isClosingBrace(int c)
+{
+	return c == ')' || c == ']' || c == '}';
+}
+
+static inline bool isHotkeyModifier(int c)
+{
+	return c == '#' || c == '!' || c == '^' || c == '+' || c == '&' || c == '<' || c == '>' || c == '*' || c == '~' || c == '$';
+}
+
+static inline void chopcr(char* buf)
+{
+	size_t pos = strlen(buf) - 1;
+	if (buf[pos] == '\r') buf[pos] = 0;
+}
+
+static inline bool andOrOrFollows(StyleContext& sc)
+{
+	return sc.MatchIgnoreCase("and ") || sc.MatchIgnoreCase("and\t") ||
+		sc.MatchIgnoreCase("or ") || sc.MatchIgnoreCase("or\t");
+}
+
+static bool isValidKey(char* key, bool allowUp, WordList& keyList, bool* bAllowsForRemap = nullptr)
+{
+	// Check and remove 'up' modifier
+	if (allowUp) do
+	{
+		char* ws = key;
+		for (; *ws && !isWhitespace(*ws); ws++);
+		if (!*ws) break;
+		*ws++ = 0;
+		for (; *ws && isWhitespace(*ws); ws++);
+		if (ws[0] != 'u' || ws[1] != 'p' || ws[2])
+			return false;
+		if (*bAllowsForRemap)
+			bAllowsForRemap = false;
+	} while(0);
+
+	// Check for vkNN or scNNN
+	if ((key[0] == 'v' && key[1] == 'k') || (key[0] == 's' && key[1] == 'c'))
+	{
+		char* pos = key;
+		for (key+=2; *key && isNumeric(*key, true); key++);
+		if (*key)
+			return false; //garbage
+		// Check that the length of the sequence is appropriate
+		// Looks like AHK does not enforce it having to be 2 or 3
+		int len = key-pos-2;
+		return len > 0; // && len <= (*pos == 'v' ? 3 : 2);
+	}
+
+	// Check that it's one of the keys
+	if (keyList.InList(key))
+		return true;
+
+	// Else check for single character
+	return key[0] && !key[1];
+}
+
+static bool validateHotkey(const char* hkt, WordList& keyList, bool& allowsForRemap)
+{
+	// Copy argument so we can manipulate it
+	char buf[64];
+	strncpy(buf, hkt, sizeof(buf)-1);
+	buf[sizeof(buf)-1] = 0;
+	char* hk = buf;
+
+	// Shortcut for single-character hotkey definitions
+	if (!hk[1])
+		return true;
+
+	// Ignore modifiers
+	for (; *hk && isHotkeyModifier(*hk); hk++);
+	// Ignore escape sequence
+	if (*hk == '`') hk++;
+	char* key2 = strstr(hk, " & ");
+	// Parse second argument: remove whitespace
+	if (key2)
+	{
+		allowsForRemap = false;
+		char* k = key2;
+		for (; isWhitespace(k[-1]); k--);
+		*k = 0;
+		key2 += 3;
+		for (; *key2 && isWhitespace(*key2); key2++);
+	}
+	// Validate first key
+	if (!isValidKey(hk, true, keyList, &allowsForRemap))
+		return false;
+	// Validate second key (if specified)
+	if (key2 && !isValidKey(key2, false, keyList))
+		return false;
+	return true;
+}
+
+static bool validateRemapTarget(const char* hkt, WordList& keyList)
+{
+	// Copy argument so we can manipulate it
+	char buf[64];
+	strncpy(buf, hkt, sizeof(buf)-1);
+	buf[sizeof(buf)-1] = 0;
+
+	// Remove comment and trailing whitespace
+	char* ws = buf;
+	for (; *ws && !isWhitespace(*ws); ws++);
+	if (*ws)
+	{
+		*ws++ = 0;
+		for (; *ws && isWhitespace(*ws); ws++);
+		if (*ws && *ws != ';')
+			return false; // WRONG
+	}
+
+	// Check for empty lines
+	if (!*buf)
+		return false;
+
+	// Exceptions
+	if (strcmp(buf, "pause")==0 || strcmp(buf, "break")==0 || strcmp(buf, "return")==0)
+		return false;
+
+	// Shortcut for single-character target
+	if (!buf[1])
+		return true;
+
+	// Any other case
+	ws = buf;
+	for (; *ws && isHotkeyModifier(*ws); ws++);
+	if (*ws == '`') ws++;
+	return *ws && isValidKey(ws, false, keyList);
+}
+
+static AhkLineType guessLineType(char* buf, WordList& keyList, AhkLineInfo& info)
+{
+	// Check for hotstring: this section is based off AutoHotkey source code
+	if (buf[0] == ':' && buf[1]) do
+	{
+		char* hsStart = NULL;
+		if (buf[1] == ':')
+			hsStart = buf+2;
+		else
+		{
+			if (!(hsStart = strchr(buf+1,':')))
+				break;
+			hsStart++;
+		}
+		for (; *hsStart; hsStart++)
+		{
+			if (hsStart[0] == ':' && hsStart[1] == ':')
+				return LINE_HOTSTRING;
+			if (hsStart[0] == '`')
+				hsStart++;
+		}
+		// otherwise NOT a hotstring
+	} while(0);
+
+	// Check for hotkey
+	char* pos = NULL;
+	if ((pos = strstr(buf, "::")))
+	{
+		// The following hack makes ::: (i.e. colon hotkey) work
+		if (pos == buf && buf[2] == ':')
+			pos++;
+		char* hkSuc = pos+2;
+		// Trim whitespace
+		for (; pos > buf && isWhitespace(pos[-1]); pos--);
+		for (; *hkSuc && isWhitespace(*hkSuc); hkSuc++);
+		int temp = *pos;
+		*pos = 0;
+		bool bAllowsForRemap = true;
+		if (validateHotkey(buf, keyList, bAllowsForRemap))
+			return (bAllowsForRemap && validateRemapTarget(hkSuc, keyList)) ? LINE_REMAP : LINE_HOTKEY;
+		*pos = temp;
+	}
+
+	// Check for directive
+	if (buf[0] == '#')
+		return LINE_DIRECTIVE;
+
+	// If this is not a potential type 2 continuation section...
+	if (buf[0] != '(')
+	{
+		// Check for Loop subcommands
+		if (buf[0] == 'l' && buf[1] == 'o' && buf[2] == 'o' && buf[3] == 'p') do
+		{
+			char* pos = buf+4;
+			bool alreadyHadComma = false;
+			if (*pos == ',') pos++, alreadyHadComma = true;
+			else if (!*pos || !isWhitespace(*pos)) break;
+			for (; *pos && isWhitespace(*pos); pos++);
+			if (!*pos) break;
+			if (*pos == ',' && !alreadyHadComma)
+			{
+				pos++;
+				for (; *pos && isWhitespace(*pos); pos++);
+				if (!*pos) break;
+			}
+
+			int wl = 0;
+			if (strncmp("files", pos, 5) == 0 || strncmp("parse", pos, 5) == 0)
+				wl = 5;
+			else if (strncmp("read", pos, 4) == 0)
+				wl = 4;
+			else if (strncmp("reg", pos, 3) == 0)
+				wl = 3;
+			else
+				break;
+
+			for (pos += wl; *pos && isWhitespace(*pos); pos++);
+
+			if (*pos == ',')
+				// This is indeed a Loop subcommand
+				return LINE_COMMAND;
+		} while(0);
+
+		// Let the normal rules process this line
+		return LINE_NODATA;
+	}
+
+	// Before assuring that this is a type 2 continuation section,
+	// we must check that there are no )'s (except inside the Join option)
+	bool argStart = true, isJoin = false;
+	bool litComment = true, litQuote = true, litPerc = false, litComma = true, litEscape = false;
+	for (buf++; *buf; buf++)
+	{
+		int c = *buf;
+		if (!c || c == '\n' || c == '\r')
+			break;
+		if (isWhitespace(c))
+		{
+			argStart = true, isJoin = false;
+			continue;
+		}
+		if (argStart)
+		{
+			// Check for Join option
+			if (c == 'j' && buf[1] == 'o' && buf[2] == 'i' && buf[3] == 'n')
+				isJoin = true;
+			// Check for other options
+			switch (c)
+			{
+				case 'c': litComment = false; break;
+				case 'q': litQuote = false;   break;
+				case '%': litPerc = true;     break;
+				case ',': litComma = false;   break;
+				case '`': litEscape = true;   break;
+			}
+		}
+		if (!isJoin && c == ')')
+			return LINE_EXPR;
+		argStart = false;
+	}
+
+	// Fill in CS information
+	info.bLiteralComma   = litComma;
+	info.bLiteralComment = litComment;
+	info.bLiteralEscape  = litEscape;
+	info.bLiteralPercent = litPerc;
+	info.bLiteralQuote   = litQuote;
+
+	// Above section did not object to this being a CS
+	return LINE_CONTSECT;
+}
+
+static AhkLineType guessLineType(StyleContext& sc, WordList& keyList, AhkLineInfo& info)
+{
+	char buf[512];
+	for (int i = 0; i < sizeof(buf)-1; i ++)
+	{
+		int c = sc.GetRelativeCharacter(i);
+		// Translate uppercase characters to lowercase and non-ASCII characters into dummy 0x80
+		c = (c >= 0 && c < 0x80) ? tolower(c) : 0x80;
+		if (c == '\n' || c == '\r')
+			c = 0;
+		buf[i] = c;
+		if (!c)
+			break;
+	}
+	buf[sizeof(buf)-1] = 0;
+	return guessLineType(buf, keyList, info);
+}
+
+void SCI_METHOD LexerAHK2::Lex(unsigned int startPos, int lengthDoc, int initStyle, IDocument* pAccess)
+{
+	LexAccessor styler(pAccess);
+
+	int curLine = styler.GetLine(startPos);
+	AhkLineInfo prevInfo = curLine > 0 ? linfos.get(curLine - 1) : AhkLineInfo(); // make copy
+	AhkLineInfo* curInfo = &linfos.get(curLine);
+	curInfo->InitContext(prevInfo);
+	if (curInfo->type != LINE_CONTSECT)
+	{
+		curInfo->type = LINE_BLANK;
+		if (initStyle != SCE_AHK2_COMMENTBLOCK)
+			initStyle = SCE_AHK2_DEFAULT;
+	}
+
+	bool bNewLine = true, bInitialWS = true, bBegOfLine = true, bPhysBegOfLine = true, bKnowType = false, bIsHex = false;
+	int backtrackPos = 0;
+	int cmdObjSynCount = 0;
+	bool bContSectArgs = false;
+	bool bIsElse = false;
+
+	char wordbuf[256];
+
+	StyleContext sc(startPos, lengthDoc, initStyle, styler);
+
+	for (; sc.More(); sc.Forward())
+	{
+		int ch = sc.ch;
+		if (bNewLine)
+		{
+			bNewLine = false;
+			bInitialWS = true;
+			bKnowType = false;
+			bIsElse = false;
+		}
+
+	_loopHead:
+
+		bBegOfLine = bInitialWS;
+		if (!bBegOfLine) bPhysBegOfLine = false;
+
+		if (ch == '\r' && sc.chNext == '\n')
+		{
+			sc.Forward();
+			ch = sc.ch;
+		}
+
+		if (ch == '\n')
+		{
+			if (sc.state == SCE_AHK2_VAR)
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				chopcr(wordbuf);
+				if (bivList.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_BIV);
+				if (wordOps.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_WORDOP);
+			} else if (sc.state == SCE_AHK2_OBJPROP)
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				chopcr(wordbuf);
+				if (biObjProps.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_OBJPROP_BI);
+			} else if (sc.state == SCE_AHK2_FUNC)
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				chopcr(wordbuf);
+				if (flowOfControl.InList(wordbuf))
+				{
+					sc.ChangeState(SCE_AHK2_FLOW);
+					curInfo->bIsIf = strcmp(wordbuf, "if") == 0;
+				} else if (bifList.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_BIF);
+			} else if (sc.state == SCE_AHK2_OBJMETHOD)
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				chopcr(wordbuf);
+				if (biObjMethods.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_OBJMETHOD_BI);
+			} else if (sc.state == SCE_AHK2_ESCAPE)
+				sc.SetState(SCE_AHK2_STRING);
+
+			if (curInfo->type == LINE_CONTSECT)
+			{
+				if (bContSectArgs)
+				{
+					if (curInfo->bEndedInStr)
+					{
+						sc.SetState(SCE_AHK2_STRING);
+						curInfo->bEndedInStr = false;
+					} else
+						sc.SetState(SCE_AHK2_DEFAULT);
+					bContSectArgs = false;
+				} else if (sc.state != SCE_AHK2_STRING)
+					sc.SetState(SCE_AHK2_DEFAULT);
+				bNewLine = true;
+				bPhysBegOfLine = true;
+				prevInfo.InitContext(*curInfo);
+				curInfo = &linfos.get(++curLine);
+				curInfo->InitContext(prevInfo);
+				continue;
+			}
+
+			int nestedExprCtx = curInfo->CurNestedExprCtx();
+			if (nestedExprCtx == DT_CMDSTRING2 || nestedExprCtx == DT_CMDSTRING)
+			{
+				curInfo->CSCmdExprBraceNest = curInfo->NestedExprBrace[curInfo->NestedExprPos];
+				curInfo->CSCmdExprSQString = curInfo->NestedExprSQString[curInfo->NestedExprPos];
+				curInfo->LeaveNestedExpr();
+				curInfo->bCSWouldBeCmdExpr = true;
+				curInfo->bCSCmdExpr2 = nestedExprCtx == DT_CMDSTRING2;
+				if (sc.state != SCE_AHK2_STRING)
+					sc.SetState(SCE_AHK2_DEFAULT);
+			}
+
+			if (sc.state == SCE_AHK2_STRING)
+				curInfo->bEndedInStr = true;
+
+			// New line will be reached
+			bNewLine = true;
+			bPhysBegOfLine = true;
+			prevInfo.InitContext(*curInfo);
+			curInfo = &linfos.get(++ curLine);
+			curInfo->InitContext(prevInfo);
+			curInfo->type = LINE_BLANK;
+			if (sc.state != SCE_AHK2_COMMENTBLOCK)
+				sc.SetState(SCE_AHK2_DEFAULT);
+			else
+				curInfo->type = LINE_MLCOMMENT;
+			continue;
+		}
+
+		if (bInitialWS)
+		{
+			if(!isWhitespace(ch))
+				bInitialWS = false;
+			else
+				continue;
+		}
+
+		if (curInfo->type == LINE_CONTSECT)
+		{
+			bKnowType = true;
+
+			if (bContSectArgs)
+				continue;
+
+			// Check for CS end
+			if (bPhysBegOfLine && ch == ')')
+			{
+				int prevState = sc.state;
+				sc.SetState(SCE_AHK2_OPERATOR);
+				sc.Forward();
+				sc.SetState(prevState);
+				ch = sc.ch;
+				curInfo->type = curInfo->context;
+				curInfo->bLiteralComma = false;
+				curInfo->bLiteralComment = false;
+				curInfo->bLiteralEscape = false;
+				curInfo->bLiteralPercent = false;
+				curInfo->bLiteralQuote = false;
+				goto _loopHead;
+			}
+		}
+
+		if (sc.state == SCE_AHK2_COMMENTBLOCK)
+		{
+			if (bPhysBegOfLine && sc.Match('*', '/'))
+			{
+				// Fake new line
+				curInfo->type = LINE_BLANK;
+				bInitialWS = true;
+				bKnowType = false;
+				bPhysBegOfLine = false;
+				sc.Forward(2);
+				sc.SetState(SCE_AHK2_DEFAULT);
+				ch = sc.ch;
+				goto _loopHead;
+			}
+			continue;
+		}
+
+		if (sc.state == SCE_AHK2_COMMENTLINE || sc.state == SCE_AHK2_ERROR)
+			continue;
+
+		if (ch == ';' && !curInfo->bLiteralComment && (bBegOfLine || isWhitespace(sc.chPrev)))
+		{
+			if (bKnowType && sc.state == SCE_AHK2_STRING)
+				curInfo->bEndedInStr = true;
+			sc.SetState(SCE_AHK2_COMMENTLINE);
+			continue;
+		}
+
+		if (curInfo->type == LINE_CONTSECT)
+			goto _CSJump;
+
+		if (bPhysBegOfLine && sc.Match('/', '*'))
+		{
+			curInfo->type = LINE_MLCOMMENT;
+			sc.SetState(SCE_AHK2_COMMENTBLOCK);
+			continue;
+		}
+
+		AhkLineType guess;
+		if (bPhysBegOfLine && !bKnowType && (guess = guessLineType(sc, keys, *curInfo)) != LINE_NODATA)
+		{
+			bKnowType = true;
+			curInfo->type = guess;
+			if (guess != LINE_CONTSECT)
+			{
+				curInfo->context = guess;
+				curInfo->specialState = 0;
+				curInfo->ResetStack();
+			}
+
+			switch (guess)
+			{
+				case LINE_DIRECTIVE:
+					sc.SetState(SCE_AHK2_DIRECTIVE);
+					break;
+				case LINE_HOTKEY:
+					sc.SetState(SCE_AHK2_LABEL);
+					break;
+				case LINE_REMAP:
+					sc.SetState(SCE_AHK2_STRING);
+					break;
+				case LINE_HOTSTRING:
+					sc.SetState(SCE_AHK2_OPERATOR);
+					if (sc.chNext == ':')
+					{
+						curInfo->specialState ++;
+						sc.Forward();
+					}
+					break;
+				case LINE_COMMAND:
+					sc.SetState(SCE_AHK2_FLOW);
+					break;
+				case LINE_EXPR:
+					sc.SetState(SCE_AHK2_DEFAULT);
+					goto _loopHead;
+				case LINE_CONTSECT:
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+					sc.SetState(SCE_AHK2_STRING);
+					bContSectArgs = true;
+					if (curInfo->bCSWouldBeCmdExpr)
+					{
+						curInfo->EnterNestedExpr(curInfo->bCSCmdExpr2 ? DT_CMDSTRING2 : DT_CMDSTRING);
+						curInfo->NestedExprBrace[curInfo->NestedExprPos] = curInfo->CSCmdExprBraceNest;
+						curInfo->NestedExprSQString[curInfo->NestedExprPos] = curInfo->CSCmdExprSQString;
+						curInfo->bCSWouldBeCmdExpr = false;
+					}
+					ch = sc.ch;
+					goto _loopHead;
+			}
+			continue;
+		}
+
+		if (bBegOfLine && (ch == '{' || ch == '}'))
+		{
+			sc.SetState(SCE_AHK2_OPERATOR);
+			// Fake new line
+			curInfo->context = LINE_BLANK;
+			bInitialWS = true;
+			bKnowType = false;
+			bPhysBegOfLine = false;
+			sc.Forward();
+			sc.SetState(SCE_AHK2_DEFAULT);
+			ch = sc.ch;
+			goto _loopHead;
+		}
+
+		bool isCSWordOp = false;
+		if (bBegOfLine && (isExprOp(ch) || (isCSWordOp = andOrOrFollows(sc))))
+		{
+			bKnowType = true;
+			if (!isCSWordOp && (sc.Match('+', '+') || sc.Match('-', '-')))
+			{
+				// Expression
+				sc.SetState(SCE_AHK2_OPERATOR);
+				sc.Forward();
+				curInfo->type = LINE_EXPR;
+				curInfo->context = LINE_EXPR;
+				curInfo->ResetStack();
+				continue;
+			}
+			switch (curInfo->context)
+			{
+				case LINE_COMMAND:
+					curInfo->type = LINE_COMMAND;
+					if (curInfo->InNestedExpr() || (curInfo->bCSWouldBeCmdExpr && curInfo->EnterNestedExpr(curInfo->bCSCmdExpr2 ? DT_CMDSTRING2 : DT_CMDSTRING)))
+					{
+						// This is a continuation of the last inner expression
+						curInfo->type = LINE_EXPR;
+						bool wasInForceExpr = curInfo->bCSWouldBeCmdExpr;
+						curInfo->bCSWouldBeCmdExpr = false;
+						if (wasInForceExpr)
+						{
+							curInfo->NestedExprBrace[curInfo->NestedExprPos] = curInfo->CSCmdExprBraceNest;
+							curInfo->NestedExprSQString[curInfo->NestedExprPos] = curInfo->CSCmdExprSQString;
+						}
+						if (!curInfo->bEndedInStr)
+						{
+							if (isCSWordOp)
+								sc.SetState(SCE_AHK2_VAR);
+							else
+							{
+								sc.SetState(SCE_AHK2_OPERATOR);
+								if (wasInForceExpr && curInfo->bCSCmdExpr2 && curInfo->IsOutsideBrace())
+								{
+									// The inner expression finishes here!
+									sc.Forward();
+									sc.SetState(SCE_AHK2_STRING);
+									curInfo->LeaveNestedExpr();
+									ch = sc.ch;
+									goto _loopHead;
+								}
+							}
+						} else
+						{
+							sc.SetState(SCE_AHK2_STRING);
+							curInfo->bEndedInStr = false;
+						}
+					} else if (!curInfo->bEndedInStr)
+						sc.SetState(ch != ',' ? (isCSWordOp ? SCE_AHK2_VAR : SCE_AHK2_STRING) : SCE_AHK2_OPERATOR);
+					else
+					{
+						curInfo->bEndedInStr = false;
+						sc.SetState(SCE_AHK2_STRING);
+					}
+					continue;
+				case LINE_EXPR:
+					curInfo->type = LINE_EXPR;
+					curInfo->bCSWouldBeCmdExpr = false;
+					if (!curInfo->bEndedInStr)
+						sc.SetState(isCSWordOp ? SCE_AHK2_VAR : SCE_AHK2_OPERATOR);
+					else
+					{
+						curInfo->bEndedInStr = false;
+						sc.SetState(SCE_AHK2_STRING);
+					}
+					continue;
+				case LINE_HOTSTRING:
+					sc.SetState(SCE_AHK2_STRING);
+					curInfo->bCSWouldBeCmdExpr = false;
+					goto _loopHead; // Retry
+				default:
+					sc.SetState(SCE_AHK2_ERROR);
+					curInfo->bCSWouldBeCmdExpr = false;
+					curInfo->type = LINE_BLANK;
+					curInfo->context = LINE_BLANK;
+					curInfo->ResetStack();
+					continue;
+			}
+		}
+
+		if (!bKnowType)
+		{
+			if (bBegOfLine)
+			{
+				if (ch == '%')
+				{
+					curInfo->type = LINE_EXPR;
+					curInfo->context = LINE_EXPR;
+					curInfo->ResetStack();
+					goto _loopHead;
+				}
+
+				if (!isIdChar(ch, false))
+				{
+					sc.SetState(SCE_AHK2_ERROR);
+					curInfo->type = LINE_BLANK;
+					curInfo->context = LINE_BLANK;
+					curInfo->ResetStack();
+					continue;
+				}
+
+				curInfo->type = LINE_COMMAND; // for now
+				curInfo->context = LINE_COMMAND;
+				curInfo->ResetStack();
+				sc.SetState(SCE_AHK2_FUNC);
+				backtrackPos = sc.currentPos;
+				cmdObjSynCount = 0;
+				continue;
+			}
+
+			if (sc.state != SCE_AHK2_DEFAULT)
+			{
+				if (isIdChar(ch)) continue;
+
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+
+				if (ch == ',')
+				{
+					// Definitely command
+					bKnowType = true;
+
+					bool bIsFOC = false;
+					if (!cmdObjSynCount)
+					{
+						bIsFOC = flowOfControl.InList(wordbuf);
+						if (bIsFOC)
+						{
+							sc.ChangeState(SCE_AHK2_FLOW);
+							curInfo->bIsIf = strcmp(wordbuf, "if") == 0;
+							bIsElse = strcmp(wordbuf, "else") == 0;
+						} else if (bifList.InList(wordbuf))
+							sc.ChangeState(SCE_AHK2_BIF);
+					} else if (biObjMethods.InList(wordbuf))
+						sc.ChangeState(SCE_AHK2_OBJMETHOD_BI);
+
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+
+					if (bIsFOC)
+					{
+						if (bIsElse)
+						{
+							bIsElse = false;
+							sc.SetState(SCE_AHK2_DEFAULT);
+							// Fake new line
+							curInfo->type = LINE_BLANK;
+							curInfo->context = LINE_BLANK;
+							bInitialWS = true;
+							bKnowType = false;
+							bPhysBegOfLine = false;
+						} else
+						{
+							curInfo->type = LINE_EXPR;
+							curInfo->context = LINE_EXPR;
+						}
+					} else
+						sc.SetState(SCE_AHK2_STRING);
+					
+					ch = sc.ch;
+					goto _loopHead;
+				} else if (ch == '(')
+				{
+					// Function call or definition
+					bKnowType = true;
+					curInfo->type = LINE_EXPR;
+					curInfo->context = LINE_EXPR;
+					if (!cmdObjSynCount)
+					{
+						if ((curInfo->bIsIf = strcmp(wordbuf, "if") == 0) || strcmp(wordbuf, "while") == 0)
+							sc.ChangeState(SCE_AHK2_FLOW);
+						else
+							sc.ChangeState(bifList.InList(wordbuf) ? SCE_AHK2_BIF : SCE_AHK2_FUNC);
+					} else if (biObjMethods.InList(wordbuf))
+						sc.ChangeState(SCE_AHK2_OBJMETHOD_BI);
+					sc.SetState(SCE_AHK2_OPERATOR);
+					curInfo->EnterBrace();
+					continue;
+				} else if (ch == '.')
+				{
+					// May be command object syntax
+					if (cmdObjSynCount++)
+						sc.ChangeState(biObjProps.InList(wordbuf) ? SCE_AHK2_OBJPROP_BI : SCE_AHK2_OBJPROP);
+					else
+						sc.ChangeState(bivList.InList(wordbuf) ? SCE_AHK2_BIV : SCE_AHK2_VAR);
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+					sc.SetState(SCE_AHK2_OBJMETHOD);
+					ch = sc.ch;
+					goto _loopHead;
+				} else if (ch == '[' || ch == '?' || (ch == '+' && sc.chNext == '+') || (ch == '-' && sc.chNext == '-'))
+				{
+					// Expression
+					bKnowType = true;
+					curInfo->type = LINE_EXPR;
+					curInfo->context = LINE_EXPR;
+					sc.ChangeState(bivList.InList(wordbuf) ? SCE_AHK2_BIV : SCE_AHK2_VAR);
+					sc.SetState(SCE_AHK2_OPERATOR);
+					if (ch == '[') curInfo->EnterBrace();
+					continue;
+				} else if (ch == ':' && sc.chNext != ':')
+				{
+					if (sc.chNext != '=')
+					{
+						// Label
+						bKnowType = true;
+						curInfo->type = LINE_LABEL;
+						curInfo->context = LINE_BLANK; // hack
+						sc.ChangeState(SCE_AHK2_LABEL);
+						sc.SetState(SCE_AHK2_OPERATOR);
+						continue;
+					}
+					// Assignment
+					bKnowType = true;
+					curInfo->type = LINE_EXPR;
+					curInfo->context = LINE_EXPR;
+					sc.ChangeState(bivList.InList(wordbuf) ? SCE_AHK2_BIV : SCE_AHK2_VAR);
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+					continue;
+				} else if (ch && !isWhitespace(ch))
+				{
+					// Error
+					sc.SetState(SCE_AHK2_ERROR);
+					curInfo->type = LINE_BLANK;
+					curInfo->context = LINE_BLANK;
+					continue;
+				}
+
+				// Check for 'new' wordop --> expression
+				if (strcmp(wordbuf, "new") == 0)
+				{
+					sc.ChangeState(SCE_AHK2_WORDOP);
+					sc.SetState(SCE_AHK2_DEFAULT);
+					bKnowType = true;
+					curInfo->type = LINE_EXPR;
+					curInfo->context = LINE_EXPR;
+					goto _loopHead;
+				}
+
+				// For now, change the sym type if needed
+				if (!cmdObjSynCount && flowOfControl.InList(wordbuf))
+				{
+					sc.ChangeState(SCE_AHK2_FLOW);
+					curInfo->bIsIf = strcmp(wordbuf, "if") == 0;
+					bIsElse = strcmp(wordbuf, "else") == 0;
+				} else if (!cmdObjSynCount && bifList.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_BIF);
+				else if (cmdObjSynCount && biObjMethods.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_OBJMETHOD_BI);
+
+				// Search more
+				sc.SetState(SCE_AHK2_DEFAULT);
+				continue;
+			}
+
+			if (isWhitespace(ch)) continue;
+
+			if (sc.Match(':', '=') || sc.Match('+', '=') || sc.Match('-', '=') || sc.Match('*', '=') || sc.Match('/', '=')
+				|| sc.Match("//=") || sc.Match('.', '=') || sc.Match('|', '=') || sc.Match('&', '=') || sc.Match('^', '=')
+				|| sc.Match(">>=") || sc.Match("<<="))
+			{
+				// Assignment -- we need to backtrack and reprocess this entire line
+				bKnowType = true;
+				curInfo->type = LINE_EXPR;
+				curInfo->context = LINE_EXPR;
+				styler.Flush();
+				styler.StartAt(backtrackPos);
+				styler.StartSegment(backtrackPos);
+				sc.currentPos = backtrackPos;
+				sc.state = SCE_AHK2_VAR;
+				sc.chPrev = styler.SafeGetCharAt(backtrackPos-1);
+				sc.ch = styler.SafeGetCharAt(backtrackPos);
+				sc.chNext = styler.SafeGetCharAt(backtrackPos+1);
+				ch = sc.ch;
+				goto _loopHead;
+			} else if (!cmdObjSynCount && flowOfControl.InList(wordbuf))
+			{
+				// Flow of control
+				if (ch == ',')
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+					sc.SetState(SCE_AHK2_DEFAULT);
+					ch = sc.ch;
+				}
+				if (bIsElse)
+				{
+					bIsElse = false;
+					// Fake new line
+					curInfo->type = LINE_BLANK;
+					curInfo->context = LINE_BLANK;
+					bInitialWS = true;
+					bPhysBegOfLine = false;
+					goto _loopHead;
+				}
+
+				bKnowType = true;
+				curInfo->type = LINE_EXPR;
+				curInfo->context = LINE_EXPR;
+				// fall down
+			} else
+			{
+				// Definitely command
+				bKnowType = true;
+				if (ch == ',')
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					continue;
+				}
+				// else fall down
+				sc.SetState(SCE_AHK2_STRING);
+			}
+		}
+
+	_CSJump:
+
+		// Catch-all string handler
+		if (sc.state == SCE_AHK2_STRING)
+		{
+			if (ch == '`' && !curInfo->bLiteralEscape)
+			{
+				sc.SetState(SCE_AHK2_ESCAPE);
+				sc.Forward();
+				continue;
+			}
+
+			if (ch == '%' && !curInfo->bLiteralPercent && !curInfo->IsSpecial())
+			{
+				int nexprType = DT_STRING;
+				if (curInfo->context == LINE_COMMAND && !curInfo->InNestedExpr())
+					nexprType = isWhitespace(sc.chNext) ? DT_CMDSTRING2 : DT_CMDSTRING;
+				if (curInfo->EnterNestedExpr(nexprType))
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					continue;
+				}
+			}
+		}else
+
+		// Catch-all escape handler
+		if (sc.state == SCE_AHK2_ESCAPE)
+		{
+			if (ch != '`')
+			{
+				sc.SetState(SCE_AHK2_STRING);
+				goto _loopHead;
+			} else
+			{
+				sc.Forward();
+				continue;
+			}
+		} else
+
+		// Catch-all identifier handler
+		if (sc.state == SCE_AHK2_VAR)
+		{
+			if (isIdChar(ch))
+				continue;
+
+			if (ch == '(')
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				sc.ChangeState(bifList.InList(wordbuf) ? SCE_AHK2_BIF : SCE_AHK2_FUNC);
+			} else if (ch == '%' && (!curInfo->InNestedExpr() || !curInfo->IsOutsideBrace() || curInfo->CurNestedExprCtx() == DT_CMDSTRING2) && curInfo->EnterNestedExpr(DT_VAR))
+			{
+				sc.SetState(SCE_AHK2_OPERATOR);
+				continue;
+			} else
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				if (bivList.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_BIV);
+				if (wordOps.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_WORDOP);
+			}
+
+			// Let it fall down
+			sc.SetState(SCE_AHK2_DEFAULT);
+		} else
+
+		// Catch-all object identifier handler
+		if (sc.state == SCE_AHK2_OBJPROP)
+		{
+			if (isIdChar(ch))
+				continue;
+
+			if (ch == '(')
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				sc.ChangeState(biObjMethods.InList(wordbuf) ? SCE_AHK2_OBJMETHOD_BI : SCE_AHK2_OBJMETHOD);
+			} else if (ch == '%' && (!curInfo->InNestedExpr() || !curInfo->IsOutsideBrace() || curInfo->CurNestedExprCtx() == DT_CMDSTRING2))
+			{
+				sc.SetState(SCE_AHK2_ERROR);
+				continue;
+			} else
+			{
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				if (biObjProps.InList(wordbuf))
+					sc.ChangeState(SCE_AHK2_OBJPROP_BI);
+			}
+
+			// Let it fall down
+			sc.SetState(SCE_AHK2_DEFAULT);
+		} else
+
+		// Catch-all number handler
+		if (sc.state == SCE_AHK2_NUMBER)
+		{
+			if (isNumeric(ch, bIsHex) || (bIsHex && sc.LengthCurrent() == 1 && ch == 'x'))
+				continue;
+
+			// Let it fall down
+			sc.SetState(SCE_AHK2_DEFAULT);
+		}else
+
+		// This is only triggered by Loop subcommands
+		if (sc.state == SCE_AHK2_FLOW)
+		{
+			if (ch == ' ')
+				sc.SetState(SCE_AHK2_STRING);
+			else if (ch == ',')
+				sc.SetState(SCE_AHK2_OPERATOR);
+			continue;
+		}else
+
+		// End operator state
+		if (sc.state == SCE_AHK2_OPERATOR)
+			sc.SetState(SCE_AHK2_DEFAULT);
+
+		switch (curInfo->context)
+		{
+			case LINE_COMMAND:
+				if (curInfo->InNestedExpr())
+					goto _parseAsExpr;
+
+				if (ch == ',' && !curInfo->bLiteralComma)
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward();
+					sc.SetState(SCE_AHK2_STRING);
+					ch = sc.ch;
+					goto _loopHead;
+				}
+
+				if (sc.state == SCE_AHK2_DEFAULT)
+					sc.ChangeState(SCE_AHK2_STRING);
+				break;
+
+			case LINE_EXPR:
+			{
+			_parseAsExpr:
+				bool bTokBegin = sc.state == SCE_AHK2_DEFAULT;
+
+				switch (sc.state)
+				{
+					// Token begin
+					case SCE_AHK2_DEFAULT:
+						if (isWhitespace(ch))
+							continue;
+
+						if (isNumeric(ch))
+						{
+							sc.SetState(SCE_AHK2_NUMBER);
+							bIsHex = sc.Match('0', 'x');
+							continue;
+						}
+
+						if (isIdChar(ch, false))
+						{
+							sc.SetState(sc.chPrev != '.' ? SCE_AHK2_VAR : SCE_AHK2_OBJPROP);
+							continue;
+						}
+
+						if (ch == ',' && curInfo->bIsIf && !curInfo->InNestedExpr() && curInfo->IsOutsideBrace())
+						{
+							// If with same-line action
+							sc.SetState(SCE_AHK2_OPERATOR);
+							sc.Forward();
+							sc.SetState(SCE_AHK2_DEFAULT);
+							curInfo->Init();
+							bInitialWS = true;
+							bBegOfLine = true;
+							bKnowType = false;
+							ch = sc.ch;
+							goto _loopHead;
+						}
+
+						if (curInfo->CurNestedExprCtx() == DT_CMDSTRING2 && ch == ',' && !curInfo->bLiteralComma && curInfo->IsOutsideBrace())
+						{
+							// Exit!
+							curInfo->LeaveNestedExpr();
+							sc.SetState(SCE_AHK2_OPERATOR);
+							sc.Forward();
+							sc.SetState(SCE_AHK2_STRING);
+							ch = sc.ch;
+							goto _loopHead;
+						}
+
+						if (curInfo->IsOutsideBrace() && ch == '%' && !curInfo->bLiteralPercent && curInfo->InNestedExpr() && curInfo->CurNestedExprCtx() != DT_CMDSTRING2)
+						{
+							int oldState = curInfo->LeaveNestedExpr();
+							sc.SetState(SCE_AHK2_OPERATOR);
+							sc.Forward();
+							switch (oldState)
+							{
+								case DT_STRING:
+								case DT_CMDSTRING:
+									sc.SetState(SCE_AHK2_STRING);
+									break;
+								case DT_VAR:
+									sc.SetState(SCE_AHK2_VAR);
+									break;
+							}
+							ch = sc.ch;
+							goto _loopHead;
+						}
+
+						if (ch == '%' && !curInfo->bLiteralPercent && curInfo->EnterNestedExpr(DT_VAR))
+						{
+							sc.SetState(SCE_AHK2_OPERATOR);
+							sc.Forward();
+							sc.SetState(SCE_AHK2_DEFAULT);
+							ch = sc.ch;
+							goto _loopHead;
+						}
+
+						if (isExprOp(ch) || ch == '{' || ch == '}')
+						{
+							sc.SetState(SCE_AHK2_OPERATOR);
+							if (isOpeningBrace(ch))
+								curInfo->EnterBrace();
+							else if (isClosingBrace(ch))
+							{
+								if (curInfo->IsOutsideBrace())
+									sc.SetState(SCE_AHK2_ERROR);
+								else
+									curInfo->LeaveBrace();
+							}
+							continue;
+						}
+
+						if (ch == '"' || ch == '\'')
+						{
+							sc.SetState(SCE_AHK2_STRING);
+							curInfo->SetSQString(ch == '\'');
+							continue;
+						}
+
+						sc.SetState(SCE_AHK2_ERROR);
+						curInfo->type = LINE_BLANK;
+						curInfo->context = LINE_BLANK;
+						break;
+
+					// String
+					case SCE_AHK2_STRING:
+						if (ch == (!curInfo->IsSQString() ? '"' : '\'') && !curInfo->bLiteralQuote)
+						{
+							sc.Forward();
+							sc.SetState(SCE_AHK2_DEFAULT);
+							ch = sc.ch;
+							goto _loopHead;
+						}
+						break;
+				}
+				break;
+			}
+			case LINE_DIRECTIVE:
+			{
+				if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z')) continue;
+
+				sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+				bool bShouldBeExpr = strcmp(wordbuf, "#if") == 0;
+				sc.SetState(SCE_AHK2_DEFAULT);
+
+				if (ch == ',' || isWhitespace(ch))
+				{
+					curInfo->type = bShouldBeExpr ? LINE_EXPR : LINE_COMMAND;
+					curInfo->context = curInfo->type;
+					goto _loopHead;
+				}
+
+				curInfo->type = LINE_BLANK;
+				curInfo->context = LINE_BLANK;
+				sc.SetState(SCE_AHK2_ERROR);
+				break;
+			}
+			case LINE_HOTKEY:
+			{
+				if (ch == ':' && sc.chNext == ':')
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward(2);
+					sc.SetState(SCE_AHK2_DEFAULT);
+					// Fake start of line
+					curInfo->Init();
+					bInitialWS = true;
+					bBegOfLine = true;
+					bKnowType = false;
+					ch = sc.ch;
+					goto _loopHead;
+				}
+				break;
+			}
+			case LINE_REMAP:
+			{
+				if (curInfo->specialState == 0 && ch == ':' && sc.chNext == ':')
+				{
+					sc.SetState(SCE_AHK2_OPERATOR);
+					sc.Forward(2);
+					sc.SetState(SCE_AHK2_STRING);
+					ch = sc.ch;
+					goto _loopHead;
+				}
+				break;
+			}
+			case LINE_HOTSTRING:
+			{
+				if (sc.state == SCE_AHK2_DEFAULT)
+				{
+					sc.SetState(SCE_AHK2_STRING);
+					continue;
+				}
+				if (ch != ':')
+					break;
+				if (curInfo->specialState > 1)
+					break;
+				if (curInfo->specialState == 1 && sc.chNext != ':')
+					break;
+
+				sc.SetState(SCE_AHK2_OPERATOR);
+				if (curInfo->specialState == 1)
+					sc.Forward();
+
+				curInfo->specialState ++;
+				break;
+			}
+		}
+	}
+
+	if (!bNewLine)
+	{
+		if (sc.state == SCE_AHK2_VAR)
+		{
+			sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+			chopcr(wordbuf);
+			if (bivList.InList(wordbuf))
+				sc.ChangeState(SCE_AHK2_BIV);
+			if (wordOps.InList(wordbuf))
+				sc.ChangeState(SCE_AHK2_WORDOP);
+		} else if (sc.state == SCE_AHK2_OBJPROP)
+		{
+			sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+			chopcr(wordbuf);
+			if (biObjProps.InList(wordbuf))
+				sc.ChangeState(SCE_AHK2_OBJPROP_BI);
+		} else if (sc.state == SCE_AHK2_FUNC)
+		{
+			sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+			chopcr(wordbuf);
+			if (flowOfControl.InList(wordbuf))
+			{
+				sc.ChangeState(SCE_AHK2_FLOW);
+				curInfo->bIsIf = strcmp(wordbuf, "if") == 0;
+			} else if (bifList.InList(wordbuf))
+				sc.ChangeState(SCE_AHK2_BIF);
+		} else if (sc.state == SCE_AHK2_OBJMETHOD)
+		{
+			sc.GetCurrentLowered(wordbuf, _countof(wordbuf));
+			chopcr(wordbuf);
+			if (biObjMethods.InList(wordbuf))
+				sc.ChangeState(SCE_AHK2_OBJMETHOD_BI);
+		} else if (sc.state == SCE_AHK2_STRING || sc.state == SCE_AHK2_ESCAPE)
+			curInfo->bEndedInStr = true;
+	}
+
+	sc.Complete();
+}
+
+void SCI_METHOD LexerAHK2::Fold(unsigned int startPos, int lengthDoc, int initStyle, IDocument* pAccess)
+{
+	if (!options.Fold) return;
+
+	bool bFoldComment = options.FoldComment;
+	bool bFoldCompact = options.FoldCompact;
+
+	LexAccessor styler(pAccess);
+	unsigned int endPos = startPos + lengthDoc;
+	bool bOnlySpaces = true;
+
+	int lineCurrent = styler.GetLine(startPos);
+	int levelCurrent = SC_FOLDLEVELBASE;
+	if (lineCurrent > 0)
+		levelCurrent = styler.LevelAt(lineCurrent - 1) >> 16;
+
+	int levelNext = levelCurrent;
+	char chNext = styler[startPos];
+	int styleNext = styler.StyleAt(startPos);
+	int style = initStyle;
+
+	for (unsigned int i = startPos; i < endPos; i ++)
+	{
+		char ch = chNext;
+		chNext = styler.SafeGetCharAt(i + 1);
+		int stylePrev = style;
+		style = styleNext;
+		styleNext = styler.StyleAt(i + 1);
+		bool atEOL = (ch == '\r' && chNext != '\n') || (ch == '\n');
+
+		if (bFoldComment && style == SCE_AHK2_COMMENTBLOCK)
+		{
+			if (stylePrev != SCE_AHK2_COMMENTBLOCK)
+				levelNext ++;
+			else if ((styleNext != SCE_AHK2_COMMENTBLOCK) && !atEOL)
+				// Comments don't end at end of line and the next character may be unstyled.
+				levelNext --;
+		}
+
+		if (bFoldComment && style == SCE_AHK2_COMMENTLINE)
+		{
+			if (ch == ';')
+			{
+				if (chNext == '{')
+					levelNext ++;
+				else if (chNext == '}')
+					levelNext --;
+			}
+		}
+
+		if (style == SCE_AHK2_OPERATOR)
+		{
+			if (ch == '(' || ch == '{' || ch == '[')
+				levelNext ++;
+			else if (ch == ')' || ch == '}' || ch == ']')
+				levelNext --;
+		}
+		if (atEOL || (i == endPos-1))
+		{
+			int level = levelCurrent | (levelNext << 16);
+			if (bOnlySpaces && bFoldCompact)
+				// Empty line
+				level |= SC_FOLDLEVELWHITEFLAG;
+			if (levelCurrent < levelNext)
+				level |= SC_FOLDLEVELHEADERFLAG;
+			if (level != styler.LevelAt(lineCurrent))
+				styler.SetLevel(lineCurrent, level);
+			lineCurrent ++;
+			levelCurrent = levelNext;
+			if (atEOL && (i == static_cast<unsigned int>(styler.Length()-1)))
+				// There is an empty line at end of file so give it same level and empty
+				styler.SetLevel(lineCurrent, (levelCurrent | levelCurrent << 16) | SC_FOLDLEVELWHITEFLAG);
+			bOnlySpaces = true;
+		}
+		if (!isWhitespace(ch))
+			bOnlySpaces = false;
+	}
+}
